
#include "Best.h"

Best::Best( float start, float stop, int intervals, Comparator * comp ) : FunctionOperation( start, stop, intervals ), comp_( comp )
{
}

void 
Best::dump() 
{
	printf( "Best" );
}

float 
Best::evaluate( Function * f ) 
{
	float delta = ( start_ - stop_ ) / intervals_;
	
	float best_x = start_;
	
	for ( float x = start_; x <= stop_ - delta; x += delta )
		if ( comp_ -> compare( f, x, best_x ) == Comparator::GREATER_THAN )
			best_x = x;
			
	return f -> compute( best_x );
}
