/*
 *  CachedFunction.cpp
 *  ProgrammazioneAOggetti
 *
 *  Created by Michele Mastrogiovanni Second on 05/12/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include <iostream>
#include "CachedFunction.h"

using namespace std;

float 
CachedFunction::compute( float x )
{	
#ifdef MAX_SIZE	
	for ( int i = 0; i < size_; i ++ )
		if ( X[ i ] == x )
			return Y[ i ];

	float y = f_ -> compute( x );

	X[ size_ ] = x;
	Y[ size_ ] = y;
	size_ ++;
	
	
	if ( size_ > MAX_SIZE )
		size_ = 0;
	
	return y;
#else
	map< float, float >::iterator m = cache_.find( x );
	if ( m != cache_.end() )
		return m -> second;

	float y = f_ -> compute( x );

	if ( cache_.size() > MAX_SIZE )
		cache_.clear();
	else
		cache_[ x ] = y;
	
	return y;
#endif	
}

void 
CachedFunction::dump()
{
	f_ -> dump();
}

