
#include "DefiniteIntegral.h"

void 
DefiniteIntegral::dump() {
	printf( "Definite Integral between %.3f and %.3f (steps: %d)", start_, stop_, intervals_ );
}

DefiniteIntegral::DefiniteIntegral( float start, float stop, int intervals ) : FunctionOperation( start, stop, intervals ) {
}

float 
DefiniteIntegral::evaluate( Function * f ) 
{
	float result = 0.0;
	double delta = ( stop_ - start_ ) / intervals_;
	
	for ( int i = 0; i < intervals_; i++ )
		result += delta * f -> compute( start_ + i * delta );
	
	return result;
}

